from PyTASTileType import *
import copy
import os

X = 0
Y = 1
Z = 2

class TileAndLocation:
	tileName = ""
	location = [0, 0, 0]

	def __init__(self, tileName = "", location = [0,0,0]):
		self.tileName = tileName
		self.location = location

	def Print(self):
		print self.tileName + " " + str(self.location)

class TDP:
	name = ""
	tdsFile = ""
	temperature = 0
	TileAndLocationList = []

	def __init__(self, name, tdsFile = "", temperature = 2, TileAndLocationData = []):
		if ".tdp" not in name:
			name += ".tdp"
		self.name = name
		if TileAndLocationData == []:
			self.TileAndLocationList = list()
		else:
			self.TileAndLocationList = TileAndLocationData
		self.temperature = temperature
		if ".tds" not in tdsFile:
			tdsFile += ".tds"
		self.tdsFile = tdsFile

	def Write(self):
		if not os.path.exists("./TDPTDS"):
			os.makedirs("./TDPTDS")
		with open("./TDPTDS/" + self.name, "w") as outFile:
			outFile.write(self.Output())
		print "Wrote " + str(len(self.TileAndLocationList)) + " tiles to " + self.name

	def Output(self):
		ret = ""
		ret += self.tdsFile + "\n"
		ret += "Temperature=" + str(self.temperature) + "\n"
		ret += self.OutputWithoutHeader()
		return ret

	def OutputWithoutHeader(self):
		ret = ""
		for TandL in self.TileAndLocationList:
			ret += TandL.tileName + " " + " ".join([str(loc) for loc in TandL.location]) + "\n"
		return ret

	def Print(self):
		print(self.tdsFile)
		print("Temperature=" + str(self.temperature))
		self.PrintWithoutHeader()

	def PrintWithoutHeader(self):
		for TandL in self.TileAndLocationList:
			if not isinstance(TandL, TileAndLocation):
				print str(TandL) + "\t" + str(type(TandL))
				continue
			print(TandL.tileName + " " + " ".join([str(loc) for loc in TandL.location]))

	def AddTile(self, tileName, location):
		self.TileAndLocationList.append(TileAndLocation(tileName, location))


#Function: Takes as input a plaintext file name
def parseTDP(tdpFileName):
	tdp = TDP(tdpFileName)
	if ".tdp" not in tdpFileName:
		print "ERROR, INVALID SUFFIX FOR " + tdpFileName + "\n"
		print "Suffix should be .tdp\n"
		return None
	with open(tdpFileName, "r") as tdpFile:
		content = tdpFile.readlines()
		for line in content:
			line = line.strip("\n")
			if ".tds" in line:
				tdp.tdsFile = line
				continue
			elif "Temperature=" in line:
				tdp.temperature = int(line.replace("Temperature=",""))
				continue
			elif line == "":
				continue
			else:
				tileAndLocation = TileAndLocation()
				lineData = line.split(" ")
				tileAndLocation.tileName = lineData[0]
				tileAndLocation.location[0] = int(lineData[1])
				tileAndLocation.location[1] = int(lineData[2])
				tileAndLocation.location[2] = int(lineData[3])
				tdp.TileAndLocationList.append(copy.deepcopy(tileAndLocation))

	return tdp




